### R code from vignette source 'ruleR.Rnw'

###################################################
### code chunk number 1: ruleR.Rnw:194-195 (eval = FALSE)
###################################################
## install.packages("ruleR", repos="http://R-Forge.R-project.org")


###################################################
### code chunk number 2: ruleR.Rnw:198-199
###################################################
library(ruleR)


###################################################
### code chunk number 3: ruleR.Rnw:202-203
###################################################
help(ruleR)


###################################################
### code chunk number 4: ruleR.Rnw:206-207
###################################################
singleRules


###################################################
### code chunk number 5: ruleR.Rnw:210-211
###################################################
doubleRules


###################################################
### code chunk number 6: ruleR.Rnw:214-219
###################################################
idrule <- new("IdenSingleRule")
add5 <- new("AddConstSingleRule", constantVal = 5, previousRule = idrule)
mult2 <- new("MultConstSingleRule", constantVal = 2, previousRule = idrule)
neg <- new("MultConstSingleRule", constantVal = -1, previousRule = idrule)
DS <- new("DigSumSingleRule")


###################################################
### code chunk number 7: ruleR.Rnw:222-224
###################################################
calculate(add5, 11)
calculate(mult2, 23)


###################################################
### code chunk number 8: ruleR.Rnw:227-229
###################################################
unlist(sequenceR(11, add5, 6)[[1]])
unlist(sequenceR(2, neg, 6)[[1]])


###################################################
### code chunk number 9: ruleR.Rnw:233-237
###################################################
DSadd5 <- new("AddConstSingleRule", constantVal = 5, previousRule = DS)
add5DS <- new("DigSumSingleRule", previousRule = add5)
unlist(sequenceR(11, DSadd5, 6)[[1]])
unlist(sequenceR(11, add5DS, 6)[[1]])


###################################################
### code chunk number 10: ruleR.Rnw:296-299
###################################################
fib <- new("AddDoubleRule", firstRule = idrule, secondRule = idrule, 
           nextSingle = idrule)
unlist(sequenceR(c(1,1), fib, 6)[[1]])


###################################################
### code chunk number 11: ruleR.Rnw:304-307
###################################################
complex <- new("AddDoubleRule", firstRule = add5, secondRule = mult2, 
           nextSingle = DS)
unlist(sequenceR(c(1,1), complex, 6)[[1]])


###################################################
### code chunk number 12: ruleR.Rnw:386-387
###################################################
print(complex)


###################################################
### code chunk number 13: ruleR.Rnw:392-401
###################################################
setClass("ModuloSingleRule",
         contains="SingleRule",
         representation(constantVal="numeric"),
         S3methods=TRUE)

setMethod("calculateSpecific",signature(x="ModuloSingleRule", y="numeric"),
          function(x,y){
            return(y%%x@constantVal)
          })


###################################################
### code chunk number 14: ruleR.Rnw:404-405
###################################################
mod7 <- new("ModuloSingleRule", constantVal = 7, previousRule = idrule)


###################################################
### code chunk number 15: ruleR.Rnw:408-412
###################################################
mult2mod7 <- new("ModuloSingleRule", constantVal = 7, previousRule = mult2)
add5mod12 <- new("ModuloSingleRule", constantVal = 12, previousRule = add5)
unlist(sequenceR(1,mult2mod7,6)[[1]])
unlist(sequenceR(1,add5mod12,6)[[1]])


